<?php
/**
 * Created by PhpStorm.
 * User: zhuangxin
 * Date: 16-9-14
 * Time: 下午5:48
 */
namespace App\Article\Model;
use App\Traits\Models;
use Illuminate\Database\Eloquent\Model;
use App\Article\Model\Keywords;
use App\Kw\Model\Keywords as BaseKeyWords;

class Art extends Model
{
    use Models;

    const ARTICLE  =  0;
    const ACTIVE   =  1;

    static $NAME = [
        self::ARTICLE   => "攻略",
        self::ACTIVE    => "动态"
    ];

    protected $table = "myp_article";

    public function relation_keywords()
    {
        return $this->hasMany(Keywords::class,"article_id")->select(Keywords::fields);
    }


    public static function newArt($data)
    {
        $model = new self;
        DB::beginTransaction();
        try {
            $model->fill($data);
            if (isset($data['keywords']) && !empty($data['keywords'])) {
               $keywords_list = [];
               foreach ($data['keywords'] as $keyword) {
                   $keywords = new Keywords();
                   $words = BaseKeyWords::getIdByWords($keyword,$data['uid'],true);
                   $keywords->kw = $words->kw_name;
                   $keywords->kw_id = $words->id;
                   array_push($keywords_list,$keywords);
               }
               $model->relation_keywords()->saveMany($keywords_list);
            }
            $model->save();
        } catch (\Exception $e) {
            DB::rollBack();
            return false;
        }
        DB::commit();
        return $model;
    }

    public function uptArt($data)
    {
        DB::beginTransaction();
        try {
            $this->fill($data);
            if (isset($data['keywords']) && !empty($data['keywords'])) {
                $keywords_list = [];
                foreach ($data['keywords'] as $keyword) {
                    $keywords = new Keywords();
                    $words = BaseKeyWords::getIdByWords($keyword,$data['uid'],true);
                    $keywords->kw = $words->kw_name;
                    $keywords->kw_id = $words->id;
                    array_push($keywords_list,$keywords);
                }
                $this->relation_keywords()->delete();
                $this->relation_keywords()->saveMany($keywords_list);
            }
            $this->save();
        } catch (\Exception $e) {
            DB::rollBack();
            return false;
        }
        DB::commit();
        return true;
    }

}